﻿using System.Xml.Linq;
public class SR2CraftColorShifter
{
    private static void Main()
    {
        string baseName, addedName;
        var path = GrabPath();
        var baseCraft = GrabCraft(Path.Combine(path, baseName = GetCraftName(path, "Base craft name:")) + ".xml");
        var addedCraft = GrabCraft(Path.Combine(path, addedName = GetCraftName(path, "Added craft name:")) + ".xml");
        var baseMaterials = baseCraft.Descendants("Theme").First().Descendants("Material");
        var addedMaterials = addedCraft.Descendants("Theme").First().Descendants("Material");

        var baseCount = baseMaterials.Count();
        baseMaterials.Last().AddAfterSelf(addedMaterials);
        addedCraft.Descendants("Theme").First().ReplaceNodes(baseMaterials);

        foreach (var m in addedCraft.Descendants().Attributes("materials"))
        {
            m.Value = String.Join(',',
            m.Value.Split(',')
            .Select(Int32.Parse)
            .Select(v => { return v + baseCount; }));
        }

        Console.WriteLine();
        SaveCraft(baseCraft, path, baseName, $"{baseName}_base_color-shifted");
        SaveCraft(addedCraft, path, addedName, $"{addedName}_added_color-shifted");
        Console.WriteLine("\nDone!");
        Console.ReadLine();

        string GrabPath()
        {
            Console.WriteLine("Path to the crafts folder:");
            return Console.ReadLine() ?? GrabPath();
        }

        string GetCraftName(string path, string text)
        {
            Console.WriteLine(text);
            return Console.ReadLine() ?? GetCraftName(path, text);
        }

        XDocument GrabCraft(string path)
        {
            var file = File.ReadAllText(path);
            return XDocument.Parse(file);
        }

        void SaveCraft(XDocument doc, string path, string oldName, string newName)
        {
            doc.Save(Path.Combine(path, newName));
            Console.WriteLine($"Saved {oldName} as {newName}");
        }
    }
}